/**
 *  The Hybrid Tree Framework for Semantic Parsing and Language Generation
 *
 *  Copyright (C) 2009  LU, Wei (luwei@statnlp.com)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


package hybridtree.data;

public class InnerFeature extends Feature {

	private static final long serialVersionUID = 5955209989143604900L;

	/**
     * Constructor
     * @param f the string representation of the feature
     */
    protected InnerFeature(String f) {
        super(f);
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("InnerFeature:");
        sb.append(this.getFeatureStr());
        sb.append('|');
        sb.append(this.getFeatureId());
        return sb.toString();
    }
}
