/**
 *  The Hybrid Tree Framework for Semantic Parsing and Language Generation
 *
 *  Copyright (C) 2009  LU, Wei (luwei@statnlp.com)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package hybridtree.data;


/**
 * @author LU Wei
 * @version 1.0
 */

public class NonterminalNode extends Node {

	private static final long serialVersionUID = 6211702069045957717L;
	
	private int nontIndices = -1;

    /**
     * Constructor
     * @param name the string representation of the NonterminalNode
     */
    protected NonterminalNode(String name) {
        super(name);
    }

    /**
     * Set the index for the NonterminalNode
     * @param nontIndex the index
     */
    public void setNontIndex(int nontIndex) {
        this.nontIndices = nontIndex;
    }

    /**
     * Get the index of the NonterminalNode
     * @return the index associated with the NonterminalNode
     */
    public int getNontIndex() {
        return this.nontIndices;
    }

}

