/**
 *  The Hybrid Tree Framework for Semantic Parsing and Language Generation
 *
 *  Copyright (C) 2009  LU, Wei (luwei@statnlp.com)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package hybridtree.data;

/**
 * @author Wei LU
 * @version 1.0
 */
public class Rule {

    public static final int RULE_w = 0;

    public static final int totalRules_0 = 1;

    public static final int RULE_X = 1;
    public static final int RULE_Xw = 2;
    public static final int RULE_wX = 3;
    public static final int RULE_w1Xw2 = 4;

    public static final int totalRules_1 = 5;

    public static final int RULE_XY = 5;
    public static final int RULE_YX = 6;
    public static final int RULE_wXY = 7;
    public static final int RULE_wYX = 8;
    public static final int RULE_XwY = 9;
    public static final int RULE_YwX = 10;
    public static final int RULE_XYw = 11;
    public static final int RULE_YXw = 12;

    public static final int RULE_w1Xw2Y = 13;
    public static final int RULE_w1Yw2X = 14;
    public static final int RULE_w1XYw2 = 15;
    public static final int RULE_w1YXw2 = 16;
    public static final int RULE_Xw1Yw2 = 17;
    public static final int RULE_Yw1Xw2 = 18;
    public static final int RULE_w1Xw2Yw3 = 19;
    public static final int RULE_w1Yw2Xw3 = 20;

    public static final int totalRules_2 = 21;

    public static boolean isReversed(int rulePattern) {
        if (rulePattern <= totalRules_1) {
            return false;
        }
        return rulePattern % 2 == 0 ? true : false;
    }

    /**
     * Get the rule patterns
     * @return array of rule patterns
     */
    public static int[] getRulePatterns() {
        int[] patterns = new int[totalRules_2];
        for (int i = 0; i < totalRules_2; i++) {
            patterns[i] = i;
        }
        return patterns;
    }
}
