/**
 *  The Hybrid Tree Framework for Semantic Parsing and Language Generation
 *
 *  Copyright (C) 2009  LU, Wei (luwei@statnlp.com)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package hybridtree.data;

/**
 * @author Wei LU
 * @version 1.0
 */
import java.util.ArrayList;


public class TestExample extends Example {

	private static final long serialVersionUID = 6944222047886159502L;

	public TestExample(int exampleId, String nl, ArrayList<Word> words, String mrl,
                       ArrayList<Production> productions) {
        super(exampleId, nl, words, mrl, productions);
    }

    /**
     * WARNING: This method is for debugging only. 
     * Do NOT call it unless you know what you are doing!!
     * @return Production
     */
    public Production getProd() {
        return this._productions.get(0);
    }

    /**
     * Get the known words
     * @return ArrayList
         public ArrayList<Word> getKnownWords(){
        ArrayList<Word> knownWords = new ArrayList<Word>();
        for(int i =0; i<this._words.size(); i++){
            Word word = this._words.get(i);
            if(!word.equals(Word.UNKNOWN)){
                knownWords.add(word);
            }
        }
        return knownWords;
         }
     */

    /**
     * Remove those unknown words.
     */
    public void removeUnknowns() {
        for (int i = 0; i < this._words.size(); i++) {
            Word word = this._words.get(i);
            if (word.equals(Word.UNKNOWN)) {
                this._words.remove(i);
                i--;
            }
        }
    }

}
