/**
 *  The Hybrid Tree Framework for Semantic Parsing and Language Generation
 *
 *  Copyright (C) 2009  LU, Wei (luwei@statnlp.com)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package hybridtree.eval;

/**
 * @author Wei LU
 * @version 1.0
 */
import java.io.*;

public class F {

    public static void main(String args[]) throws IOException {
        BufferedReader stdin = new BufferedReader(new InputStreamReader(System.
                in));

        String line;
        double total = 0;
        double predicted = 0;
        double corr = 0;
        double best = 0;
        while ((line = stdin.readLine()) != null) {
            line = line.trim();
            if (line.startsWith("Total")) {
                int index = line.indexOf(":");
                double value = Double.parseDouble(line.substring(index + 1));
                total += value;
            }
            if (line.startsWith("Parsed")) {
                int index = line.indexOf(":");
                double value = Double.parseDouble(line.substring(index + 1));
                predicted += value;
            }
            if (line.startsWith("Max   Correct")) {
                int index = line.indexOf(":");
                double value = Double.parseDouble(line.substring(index + 1));
                corr += value;
            }
            if (line.startsWith("Best Can Do")) {
                int index = line.indexOf(":");
                double value = Double.parseDouble(line.substring(index + 1));
                best += value;
            }
        }
        double R = corr / total;
        double P = corr / predicted;
        double F = 2.0 / (1.0 / P + 1.0 / R);

        double R_best = best / total;
        double P_best = best / predicted;
        double F_best = 2.0 / (1.0 / P_best + 1.0 / R_best);

        System.out.println("P=" + P);
        System.out.println("R=" + R);
        System.out.println("F=" + F);

        System.out.println("P_best=" + P_best);
        System.out.println("R_best=" + R_best);
        System.out.println("F_best=" + F_best);
    }

}
