/**
 *  The Hybrid Tree Framework for Semantic Parsing and Language Generation
 *
 *  Copyright (C) 2009  LU, Wei (luwei@statnlp.com)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package hybridtree.eval;

import java.io.*;
import java.util.*;

import hybridtree.util.Pair;

public class ResultChecker {
    public static void main(String args[]) throws IOException {
        FileInputStream infile1 = new FileInputStream(args[0]);
        BufferedReader stdin1 = new BufferedReader(new InputStreamReader(
                infile1));

        FileInputStream infile2 = new FileInputStream(args[1]);
        BufferedReader stdin2 = new BufferedReader(new InputStreamReader(
                infile2));

        HashMap<String, Pair<Double, Integer>> qidTable = new HashMap<String, Pair<Double, Integer>>();

        String line1;
        String line2;
        while ((line1 = stdin1.readLine()) != null) {
            line2 = stdin2.readLine();
            double value = Double.parseDouble(line2);

            StringTokenizer st = new StringTokenizer(line1);
            int flag = Integer.parseInt(st.nextToken());
            String qid = st.nextToken();

            Pair<Double, Integer> p = new Pair<Double, Integer>(value, flag);

            if (!qidTable.containsKey(qid)) {
                qidTable.put(qid, p);
            } else {
                Pair<Double,
                        Integer>
                        p_old = (Pair<Double, Integer>) qidTable.get(qid);
                if ((Double) p_old.getFirst() < value) {
                    qidTable.put(qid, p);
                }
            }
        }

        double corr = 0;
        double pred = 0;
        Iterator<String> keys = qidTable.keySet().iterator();
        while (keys.hasNext()) {
            pred++;
            String qid = keys.next();
            Pair<Double, Integer> p = qidTable.get(qid);
            if ((Integer) p.getSecond() == 2) {
                corr++;
            }
        }
        System.err.println(pred);
        System.err.println(corr);
    }
}
