/**
 *  The Hybrid Tree Framework for Semantic Parsing and Language Generation
 *
 *  Copyright (C) 2009  LU, Wei (luwei@statnlp.com)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package hybridtree.util;
import java.util.*;

/*
 * @author LU, Wei
 * @version 1.0
 */
public class CountTable {

    private HashMap<Object, Double> _table;

    public CountTable() {
        this._table = new HashMap<Object, Double>();
    }

    public void add(Object key) {
        if (!this._table.containsKey(key)) {
            this._table.put(key, 1.0);
        } else {
            double oldCount = this._table.get(key);
            this._table.put(key, oldCount + 1.0);
        }
    }

    public double get(Object key) {
        return this._table.get(key);
    }

    public Object[] keys() {
        Object[] results = new Object[this._table.size()];

        int index = 0;
        Iterator<Object> keys = this._table.keySet().iterator();
        while (keys.hasNext()) {
            results[index++] = keys.next();
        }

        return results;
    }

}
