/**
 *  The Hybrid Tree Framework for Semantic Parsing and Language Generation
 *
 *  Copyright (C) 2009  LU, Wei (luwei@statnlp.com)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package hybridtree.util;

/**
 * @author LU, Wei
 * @version 1.0
 */

public class KeyGen {

    public static long toKey(int x, int y, int z, int w) {
        return toKey(toKey(toKey((long) x, (long) y), (long) z), (long) w);
    }

    public static long toKey(int x, int y, int z) {
        return toKey(toKey((long) x, (long) y), (long) z);
    }

    public static long toKey(int x, int y) {
        return toKey((long) x, (long) y);
    }

    public static long toKey(long a, long b) {
        return a * 10000 + b;
    }

    public static int[] rev2Key(long key) {
        int b = (int) (key % 10000);
        int a = (int) (key / 10000);
        return new int[] {a, b};
    }

}
